import pygame
import UI

def load_pix():
	Bucket.picture = UI.load_picture("bucket")
	Bucket.cursor = UI.load_cursor("bucket", UI.CURSOR_OWN_MASK)
	Bucket.width = Bucket.picture.get_width()
	Bucket.height = Bucket.picture.get_height()

class Bucket:
	def __init__(self):
		self.grabbed = 0

	def clicked(self, x, y):
		return x > 0 and x < self.width and y > 0 and y < self.height

	def draw(self, screen):
		if not self.grabbed:
			screen.blit(self.picture, (0, 0))

	def grab(self):
		UI.set_cursor(self.cursor)
		self.grabbed = 1

	def release(self, x, y, cables):
		for cable in cables:
			if cable.onspark(x, y):
				cable.reset()
		self.grabbed = 0
