import Bill
import Computer
import Network
import UI
from util import RAND

COUNTER_OFF = 0
COUNTER_ON = 1
MAX_COUNTERS = 2

MAX_BILLS = 100		# max Bills per level

def max_at_once(lev):
	return 

def between(lev):
	return 

class Horde:
	def __init__(self):
		self.counters = range(MAX_BILLS)
	
	def setup(self, game):
		self.alive = []
		self.strays = []
		self.counters[COUNTER_OFF] = min(int((8 + 3 * game.level) * game.scale(2)), MAX_BILLS)
		self.counters[COUNTER_ON] = 0

	# Launches Bills whenever called
	def launch(self, max, game):
		off_screen = self.counters[COUNTER_OFF]
		if max == 0 or off_screen == 0:
			return
		n = RAND(1, min(max, off_screen + 1))
		for i in range(n):
			self.alive[:0] = [Bill.Bill(self, game)]

	def update(self, game):
		if game.iteration % max(14 - game.level / 3, 10) == 0:
			self.launch(min(2 + game.level / 4, 12), game)
		for bill in self.alive:
			bill.update(game)

	def draw(self, screen):
		for bill in self.strays:
			bill.draw(screen)
		for bill in self.alive:
			bill.draw(screen)

	def move_bill(self, bill):
		self.alive.remove(bill)
		self.strays[:0] = [bill]

	def remove_bill(self, bill, network):
		if bill.state == Bill.STATE_STRAY:
			self.strays.remove(bill)
		else:
			self.alive.remove(bill)
		network.clear_stray(bill)
		del bill

	def add_bill(self, bill):
		if bill.state == Bill.STATE_STRAY:
			self.strays[:0] = [bill]
		else:
			self.alive[:0] = [bill]

	def clicked_stray(self, x, y):
		for bill in self.strays:
			if not bill.clickedstray(x, y):
				continue
			return bill
		return None

	def process_click(self, x, y):
		counter = 0

		for bill in self.alive:
			if bill.state == Bill.STATE_DYING or not bill.clicked(x, y):
				continue
			if bill.state == Bill.STATE_AT:
				bill.target_c.busy = 0
				bill.target_c.stray = bill
			bill.set_dying()
	       		counter += 1
		return counter
