import pygame
from os.path import join

from util import fatal
from cursors import load_xbm

CURSOR_SEP_MASK = 0
CURSOR_OWN_MASK = 1

def set_cursor(cursor):
	pygame.mouse.set_cursor(cursor[0], cursor[1], cursor[2], cursor[3])

def load_picture_indexed(name, index):
	if index > 99:
		fatal('image index too large')
	newname = ('%s_%d' % (name, index))
	return load_picture(newname)

def load_picture(name):
	file = join('pixmaps', ('%s.xpm' % name))
	return pygame.image.load(file).convert()

def load_cursor(name, masked):
	filename = join('bitmaps', ('%s.xbm' % name))
	if masked is CURSOR_SEP_MASK:
		maskname = join('bitmaps', ('%s_mask.xbm' % name))
	else:
		maskname = filename
	cursor = load_xbm(filename, maskname)
	return cursor[0], (cursor[0][0] / 2, cursor[0][1] / 2), cursor[2], cursor[3]

def intersect(x1, y1, w1, h1, x2, y2, w2, h2):
	return (abs(x2 - x1 + (w2 - w1) / 2) < (w1 + w2) / 2) and (abs(y2 - y1 + (h2 - h1) / 2) < (h1 + h2) / 2)

refresh = pygame.display.flip
set_icon = pygame.display.set_icon